<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:c="http://java.sun.com/jstl/core"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <h1>#{worklistEntryCreator.domain.name} #{messages['gazelle.ordermanager.WorklistEntryCreator']}</h1>
            <s:div id="globalDiv">
                <!-- display scheduled procedure steps -->
                <s:div id="selectionDiv"
                       rendered="#{worklistEntryCreator.selectedOrder == null and worklistEntryCreator.selectedProcedureStep == null and worklistEntryCreator.selectedRequestedProcedure == null}">
                    <gri:panel pid="listSPSPanel" rendered="#{worklistEntryCreator.selectionType == 'SPS'}">
                        <f:facet name="header">#{messages['gazelle.ordermanager.SelectAScheduledProcedureStep']}
                        </f:facet>
                        <a4j:commandButton actionListener="#{worklistEntryCreator.listObjects('ORDER')}"
                                           render="globalDiv"
                                           value="#{messages['gazelle.ordermanager.ScheduleAnOrder']}"
                                           styleClass="gzl-btn-blue"/>

                        <br/><br/>
                        <!-- filters -->
                        <f:subview id="subview_sps">
                            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                <ui:define name="filter_buttons">
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                     render="listSPSPanel">
                                        <span class="gzl-icon-refresh"/>
                                    </a4j:commandLink>
                                    <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                     actionListener="#{worklistEntryCreator.spsFilter.reset()}"
                                                     render="listSPSPanel">
                                        <span class="gzl-icon-times-circle"/>
                                    </a4j:commandLink>
                                </ui:define>
                                <ui:include src="/common/filtersOnOrder.xhtml">
                                    <ui:param name="filterClass" value="#{worklistEntryCreator.spsFilter}"/>
                                    <ui:param name="formId" value="listSPSPanel"/>
                                </ui:include>
                            </ui:decorate>
                        </f:subview>
                        <br/><br/>
                        <rich:dataTable value="#{worklistEntryCreator.spsFilter.getProcedureSteps()}" var="sps"
                                        rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="spsTable"
                                        render="ds">
                            <ui:include src="/common/scheduledProcedureStepColumns.xhtml">
                                <ui:param name="sps" value="#{sps}"/>
                            </ui:include>
                            <g:column>
                                <ui:define name="header">#{messages['users.Action']}</ui:define>
                                <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                 actionListener="#{worklistEntryCreator.selectScheduledProcedureStep(sps)}"
                                                 render="globalDiv">
                                    <span class="fa fa-th-list gzl-text-blue"/>
                                </a4j:commandLink>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="spsTable"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                    </gri:panel><!-- display orders -->
                    <gri:panel pid="listOrdersPanel" rendered="#{worklistEntryCreator.selectionType == 'ORDER'}">
                        <f:facet name="header">#{messages['gazelle.ordermanager.SelectAnOrderToSchedule']}</f:facet>
                        <a4j:commandButton actionListener="#{worklistEntryCreator.listObjects('SPS')}"
                                           value="#{messages['gazelle.ordermanager.BackToScheduledProcedureStepSelection']}"
                                           render="globalDiv" styleClass="gzl-btn-orange"/>
                        <a4j:commandButton
                                actionListener="#{worklistEntryCreator.listObjects('ENCOUNTER')}"
                                value="#{messages['gazelle.ordermanager.CreateANewOrderForAnExistingEncounter']}"
                                render="globalDiv"
                                styleClass="gzl-btn-blue"/>
                        <!-- filters -->
                        <br/><br/>
                        <f:subview id="subview_order">
                            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                <ui:define name="filter_buttons">
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                     render="listOrdersPanel">
                                        <span class="gzl-icon-refresh"/>
                                    </a4j:commandLink>
                                    <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                     actionListener="#{worklistEntryCreator.orderFilter.reset()}"
                                                     render="listOrdersPanel">
                                        <span class="gzl-icon-times-circle"/>
                                    </a4j:commandLink>
                                </ui:define>
                                <ui:include src="/common/filtersOnOrder.xhtml">
                                    <ui:param name="filterClass" value="#{worklistEntryCreator.orderFilter}"/>
                                    <ui:param name="formId" value="listOrdersPanel"/>
                                </ui:include>
                            </ui:decorate>
                        </f:subview>
                        <rich:dataTable value="#{worklistEntryCreator.orderFilter.getOrders()}" var="orc"
                                        rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="ordersTable"
                                        render="ds">
                            <ui:include src="/common/orderColumns.xhtml">
                                <ui:param name="currentOrder" value="#{orc}"/>
                                <ui:param name="displayEncounterInfo" value="true"/>
                            </ui:include>
                            <g:column>
                                <ui:define name="header">#{messages['users.Action']}</ui:define>
                                <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                 actionListener="#{worklistEntryCreator.scheduleOrder(orc)}"
                                                 render="globalDiv">
                                    <span class="gzl-icon-calendar-o"/>
                                </a4j:commandLink>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="ordersTable"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                    </gri:panel><!-- display encounters -->
                    <gri:panel pid="listEncountersPanel"
                               rendered="#{worklistEntryCreator.selectionType == 'ENCOUNTER'}">
                        <f:facet name="header">
                            #{messages['gazelle.ordermanager.SelectAnEncounterForWhichYouWantToCreateAnOrder']}
                        </f:facet>
                        <a4j:commandButton actionListener="#{worklistEntryCreator.listObjects('ORDER')}"
                                           render="globalDiv" styleClass="gzl-btn-orange"
                                           value="#{messages['gazelle.ordermanager.BackToOrderSelection_2']}"/>
                        <br/><br/>
                        <!-- filters -->
                        <f:subview id="subview_encounter">
                            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                <ui:define name="filter_buttons">
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                     render="listEncountersPanel">
                                        <span class="gzl-icon-refresh"/>
                                    </a4j:commandLink>
                                    <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                     actionListener="#{worklistEntryCreator.encounterFilter.reset()}"
                                                     render="listEncountersPanel">
                                        <span class="gzl-icon-times-circle"/>
                                    </a4j:commandLink>
                                </ui:define>
                                <ui:include src="/common/filtersOnEncounter.xhtml">
                                    <ui:param name="formId" value="listEncountersPanel"/>
                                    <ui:param name="filterClass"
                                              value="#{worklistEntryCreator.encounterFilter}"/>
                                </ui:include>
                            </ui:decorate>
                        </f:subview>
                        <rich:dataTable id="encountersTable"
                                        value="#{procedureSender.encounterFilter.getEncounterFiltered()}"
                                        var="enc" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                        render="ds">
                            <ui:include src="/common/encounterColumns.xhtml">
                                <ui:param name="encounter" value="#{enc}"/>
                                <ui:param name="displayPatientInfo" value="true"/>
                                <ui:param name="extendedTable" value="false"/>
                            </ui:include>
                            <g:column>
                                <ui:define name="header">#{messages['users.Action']}</ui:define>
                                <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                 actionListener="#{worklistEntryCreator.selectEncounter(enc)}"
                                                 render="globalDiv">
                                    <span class="gzl-icon-medkit"/>
                                </a4j:commandLink>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="encountersTable"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                    </gri:panel>
                </s:div>
                <!-- display selected order for filling -->
                <gri:panel pid="fillOrderPanel" rendered="#{worklistEntryCreator.selectedOrder != null}">
                    <f:facet name="header">
                        <h:outputText value="#{messages['gazelle.ordermanager.createNewOrder']}"/>
                        <span style="width:10px"/>
                        <a4j:commandLink title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                         actionListener="#{worklistEntryCreator.fillOrderRandomly()}"
                                         immediate="true" render="fillOrderPanel">
                            <span class="gzl-icon-random"/>
                        </a4j:commandLink>
                    </f:facet><!-- fill randomly button -->
                    <ui:include src="/common/fillingOrder.xhtml">
                        <ui:param name="order" value="#{worklistEntryCreator.selectedOrder}"/>
                    </ui:include>
                    <f:facet name="footer">
                        <a4j:commandButton styleClass="gzl-btn-blue"
                                           value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                           actionListener="#{worklistEntryCreator.fillOrderRandomly()}"
                                           immediate="true"
                                           render="fillOrderPanel"/>
                        <a4j:commandButton styleClass="gzl-btn-blue"
                                           value="#{messages['gazelle.ordermanager.CreateTheOrderAndScheduleProcedure']}"
                                           actionListener="#{worklistEntryCreator.scheduleOrder()}"
                                           render="globalDiv"/>
                    </f:facet>
                </gri:panel><!-- display requested order for filling -->
                <gri:panel id="fillRequestedProcedure"
                           rendered="#{worklistEntryCreator.selectedRequestedProcedure != null}">
                    <f:facet name="header">#{messages['gazelle.ordermanager.RequestedProcedureToSchedule']}</f:facet>
                    <ui:include src="/common/procedureDetails.xhtml">
                        <ui:param name="proc" value="#{worklistEntryCreator.selectedRequestedProcedure}"/>
                        <ui:param name="editSPSDates" value="true"/>
                        <ui:param name="editModality" value="true"/>
                        <ui:param name="displayCreateWorklistButton" value="true"/>
                    </ui:include>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.SaveRequestedProcedure']}"
                                           actionListener="#{worklistEntryCreator.saveRequestedProcedure()}"
                                           styleClass="gzl-btn-blue"
                                           render="globalDiv"/>
                    </f:facet>
                </gri:panel><!-- display SPS and worklist missing details -->
                <gri:panel pid="worklistCreation"
                           rendered="#{worklistEntryCreator.selectedProcedureStep != null and worklistEntryCreator.selectedWorklist.id == null}">
                    <f:facet name="header">#{messages['gazelle.ordermanager.WorklistCreation']}</f:facet>
                    <dl class="dl-horizontal">
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.Patient']}</ui:define>
                            <h:outputText><a
                                    href="#{applicationConfiguration.getValueOfVariable('application_url')}/browsing/patient.seam?id=#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.encounter.patient.id}"
                                    target="_blank">
                                #{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.encounter.patient.firstName}
                                #{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.encounter.patient.lastName}
                            </a></h:outputText>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.VisitNumber']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.encounter.visitNumber}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.UniversalServiceId']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.universalServiceId}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.PlacerOrderNumber']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.placerOrderNumber}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.FillerOrderNumber']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.fillerOrderNumber}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.AccessionNumber']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.order.accessionNumber}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.RequestedProcedure_2']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.codeMeaning}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.StudyInstanceUID_2']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.studyInstanceUID}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.RequestedProcedureID_2']}
                            </ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedProcedureStep.requestedProcedure.requestedProcedureID}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.ScheduledProcedureStepID']}
                            </ui:define>
                            <h:outputText value="#{worklistEntryCreator.selectedProcedureStep.scheduledProcedureID}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml"
                                    rendered="#{not empty worklistEntryCreator.selectedProcedureStep.spsDescription}">
                            <ui:define name="label">#{messages['net.ihe.gazelle.simulators.Description']}</ui:define>
                            <h:outputText value="#{worklistEntryCreator.selectedProcedureStep.spsDescription}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.ScheduledStartDatetime']}
                            </ui:define>
                            <g:date value="#{worklistEntryCreator.selectedProcedureStep.spsStartDateTime}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.ProtocolItems']})</ui:define>
                            <rich:list value="#{worklistEntryCreator.selectedProcedureStep.protocolItems}" var="item"
                                       type="unordered">
                                <h:outputText value="#{item.protocolCodeMeaning}"/>
                            </rich:list>
                        </s:decorate>
                    </dl>
                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['gazelle.ordermanager.StationAETitle_2']}</ui:define>
                        <ui:param name="id" value="aet"/>
                        <h:inputText value="#{userPreferencesManagerBean.stationAETitle}" required="true" id="aet"
                                     styleClass="form-control"/>
                    </s:decorate>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.GenerateWorklist']}"
                                           actionListener="#{worklistEntryCreator.generateWorklist()}"
                                           styleClass="gzl-btn-blue"
                                           render="globalDiv"/>
                    </f:facet>
                </gri:panel><!-- worklist downloads -->
                <gri:panel pid="worklistDownloads"
                           rendered="#{worklistEntryCreator.selectedWorklist != null and worklistEntryCreator.selectedWorklist.id != null}">
                    <f:facet name="header">#{messages['gazelle.ordermanager.CreatedWorklist']}</f:facet>
                    <div class="gzl-alert gzl-alert-blue">
                        <h:outputText
                                value="#{messages['gazelle.ordermanager.ToRetrieveYourWorklistUsingADICOMQueryUseThePara']}"/>
                    </div>
                    <dl class="dl-horizontal">
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.ScheduledStationAETitle_2']}
                            </ui:define>
                            <h:outputText value="#{worklistEntryCreator.selectedWorklist.stationAETitle}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.SCPAETitle']}</ui:define>
                            <h:outputText
                                    value="#{worklistEntryCreator.selectedWorklist.domain.keyword}_#{messages['gazelle.ordermanager.OF']}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.SCPIPAddress']}</ui:define>
                            <h:outputText value="#{applicationConfiguration.getValueOfVariable('dicom_proxy_ip')}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.SCPPort']}</ui:define>
                            <h:outputText value="#{applicationConfiguration.getValueOfVariable('dicom_proxy_port')}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['gazelle.ordermanager.PermanentLink_2']}</ui:define>
                            <h:outputLink
                                    value="#{applicationConfiguration.getValueOfVariable('application_url')}/browsing/worklist.seam?id=#{worklistEntryCreator.selectedWorklist.id}"
                                    target="_blank">
                                <h:outputText
                                        value="#{applicationConfiguration.getValueOfVariable('application_url')}/browsing/worklist.seam?id=#{worklistEntryCreator.selectedWorklist.id}"/>
                            </h:outputLink>
                        </s:decorate>
                    </dl>

                    <f:facet name="footer">
                        <a4j:commandButton styleClass="gzl-btn"
                                           value="#{messages['gazelle.ordermanager.CreateAnotherWorklist']}"
                                           actionListener="#{worklistEntryCreator.performAnotherTest()}"
                                           render="globalDiv"/>
                        <h:commandLink styleClass="gzl-btn-blue"
                                       value="#{messages['gazelle.ordermanager.DownloadTheDICOMWorklist']}"
                                       actionListener="#{worklistEntryManager.downloadWorklist(worklistEntryManager.DICOM, worklistEntryCreator.selectedWorklist)}"/>
                        <h:commandLink value="#{messages['gazelle.ordermanager.DownloadAnXMLVersionOfTheWorklist']}"
                                       styleClass="gzl-btn-blue"
                                       actionListener="#{worklistEntryManager.downloadWorklist(worklistEntryManager.XML, worklistEntryCreator.selectedWorklist)}"/>
                        <h:commandLink value="#{messages['gazelle.ordermanager.DownloadADUMPVersionOfTheWorklist']}"
                                       actionListener="#{worklistEntryManager.downloadWorklist(worklistEntryManager.DUMP, worklistEntryCreator.selectedWorklist)}"
                                       rendered="false" styleClass="gzl-btn-blue"/>
                    </f:facet>
                </gri:panel>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
